/* acconfig.h
   This file is in the public domain.

   Descriptive text for the C preprocessor macros that
   the distributed Autoconf macros can define.
   No software package will use all of them; autoheader copies the ones
   your configure.in uses into your configuration header file templates.

   The entries are in sort -df order: alphabetical, case insensitive,
   ignoring punctuation (such as underscores).  Although this order
   can split up related entries, it makes it easier to check whether
   a given entry is in the file.

   Leave the following blank line there!!  Autoheader needs it.  */


/* Version of .frm files */
#undef DOT_FRM_VERSION

/* READLINE: */
#undef FIONREAD_IN_SYS_IOCTL

/* READLINE: Define if your system defines TIOCGWINSZ in sys/ioctl.h.  */
#undef GWINSZ_IN_SYS_IOCTL

/* Handing of large files on Solaris 2.6 */
#undef _FILE_OFFSET_BITS

/* bool is not defined by all C++ compilators */
#undef HAVE_BOOL

/* Can netinet be included */
#undef HAVE_BROKEN_NETINET_INCLUDES

/* READLINE: */
#undef HAVE_BSD_SIGNALS

/* Define if we are using OSF1 DEC threads */
#undef HAVE_DEC_THREADS

/* READLINE: */
#undef HAVE_GETPW_DECLS

/* Define is we have GNU readline */
#undef HAVE_LIBREADLINE

/* Define if we are using Xavier Leroy's LinuxThreads */
#undef HAVE_LINUXTHREADS

/* Do we use user level threads */
#undef HAVE_mit_thread

/* For some non posix threads */
#undef HAVE_NONPOSIX_PTHREAD_GETSPECIFIC

/* READLINE: */
#undef HAVE_POSIX_SIGNALS

/* pthread_attr_setscope */

#undef HAVE_PTHREAD_ATTR_SETSCOPE

/* POSIX readdir_r */
#undef HAVE_READDIR_R

/* POSIX sigwait */
#undef HAVE_SIGWAIT

/* Solaris define gethostbyaddr_r with 7 arguments. glibc2 defines
   this with 8 arguments */
#undef HAVE_SOLARIS_STYLE_GETHOST

/* MIT pthreads does not support connecting with unix sockets */
#undef HAVE_THREADS_WITHOUT_SOCKETS

/* Timespec has a ts_sec instead of tv_sev  */
#undef HAVE_TIMESPEC_TS_SEC

/* Define if the system files define uchar */
#undef HAVE_UCHAR

/* Define if the system files define ulong */
#undef HAVE_ULONG

/* READLINE: */
#undef HAVE_USG_SIGHOLD

/* Handling of large files on Solaris 2.6 */
#undef _LARGEFILE_SOURCE

/* Handling of large files on Solaris 2.6 */
#undef _LARGEFILE64_SOURCE

/* Define to machine type name eg sun10 */
#undef MACHINE_TYPE

/* Defined to used character set */
#undef MY_CHARSET_CURRENT

/* READLINE: no sys file*/
#undef NO_SYS_FILE

/* Program name */
#undef PACKAGE

/* mysql client protocoll version */
#undef PROTOCOL_VERSION

/* Define if qsort returns void */
#undef QSORT_TYPE_IS_VOID

/* Define as the return type of qsort (int or void). */
#undef RETQSORTTYPE

/* Size of off_t */
#undef SIZEOF_OFF_T

/* Define as the base type of the last arg to accept */
#undef SOCKET_SIZE_TYPE

/* Needed to get large file supportat HPUX 10.20 */
#undef __STDC_EXT__

/* READLINE: */
#undef STRUCT_DIRENT_HAS_D_INO

/* Define to name of system eg solaris*/
#undef SYSTEM_TYPE

/* Define if you want to have threaded code. This may be undef on client code */
#undef THREAD

/* Should be client be thread safe */
#undef THREAD_SAFE_CLIENT

/* READLINE: */
#undef TIOCSTAT_IN_SYS_IOCTL

/* Use strcoll() functions when comparing and sorting. */
#undef USE_STRCOLL

/* Program version */
#undef VERSION

/* READLINE: */
#undef VOID_SIGHANDLER


/* Leave that blank line there!!  Autoheader needs it.
   If you're adding to this file, keep in mind:
   The entries are in sort -df order: alphabetical, case insensitive,
   ignoring punctuation (such as underscores).  */
